# encoding: utf-8

# ------------------------------------------------------------------------------
# Copyright (c) 2009 Novell, Inc. All Rights Reserved.
#
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of version 2 of the GNU General Public License as published by the
# Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, contact Novell, Inc.
#
# To contact Novell about this file by physical or electronic mail, you may find
# current contact information at www.novell.com.
# ------------------------------------------------------------------------------
#

# File:		vm-install.rb
# Package:	Installation of a virtual machine
# Summary:	Main VM installation YaST frontend for python based vm-install
# Authors:	Charles E. Arnold <carnold@suse.com>
#
# $Id$
#

module Yast
  class VminstallClient < Client
    def main
      textdomain "vm-install"

      Yast.import "UI"
      Yast.import "Popup"
      Yast.import "String"

      #===================================================================
      # Start vm-install either Text (commandline) or GUI mode
      #-------------------------------------------------------------------
      status = 0
      @details = {}

      Builtins.y2milestone("START HERE.")
      if UI.TextMode()
        Builtins.y2milestone("Running vm-install in command line mode.")
        status = UI.RunInTerminal("/usr/bin/vm-install")
      else
        Builtins.y2milestone("Running vm-install in GUI mode.")
        details = Convert.to_map(SCR.Execute(path(".target.bash_output"), "/usr/bin/vm-install"))
        status = Ops.get_integer(details, "exit", -1)
      end

      Builtins.y2milestone("vm-install finished with exit code: <%1>", status)
      if status == 0
        return :next
      else
        if Builtins.size(Ops.get_string(details, "stderr", "")) > 0
          Popup.ErrorDetails(_("Failed to start vm-install"), Convert.to_string(details, "stderr", ""))
        else
          Popup.Error(_("Failed to start vm-install"))
        end
      end

      nil
    end
  end
end

Yast::VminstallClient.new.main
